
if(NOT "/tmp/qzdl.git.x4WS1h/build/_deps/inih-subbuild/inih-populate-prefix/src/inih-populate-stamp/inih-populate-gitinfo.txt" IS_NEWER_THAN "/tmp/qzdl.git.x4WS1h/build/_deps/inih-subbuild/inih-populate-prefix/src/inih-populate-stamp/inih-populate-gitclone-lastrun.txt")
  message(STATUS "Avoiding repeated git clone, stamp file is up to date: '/tmp/qzdl.git.x4WS1h/build/_deps/inih-subbuild/inih-populate-prefix/src/inih-populate-stamp/inih-populate-gitclone-lastrun.txt'")
  return()
endif()

execute_process(
  COMMAND ${CMAKE_COMMAND} -E rm -rf "/tmp/qzdl.git.x4WS1h/build/_deps/inih-src"
  RESULT_VARIABLE error_code
  )
if(error_code)
  message(FATAL_ERROR "Failed to remove directory: '/tmp/qzdl.git.x4WS1h/build/_deps/inih-src'")
endif()

# try the clone 3 times in case there is an odd git clone issue
set(error_code 1)
set(number_of_tries 0)
while(error_code AND number_of_tries LESS 3)
  execute_process(
    COMMAND "/usr/bin/git"  clone --no-checkout --config "advice.detachedHead=false" "https://github.com/benhoyt/inih.git" "inih-src"
    WORKING_DIRECTORY "/tmp/qzdl.git.x4WS1h/build/_deps"
    RESULT_VARIABLE error_code
    )
  math(EXPR number_of_tries "${number_of_tries} + 1")
endwhile()
if(number_of_tries GREATER 1)
  message(STATUS "Had to git clone more than once:
          ${number_of_tries} times.")
endif()
if(error_code)
  message(FATAL_ERROR "Failed to clone repository: 'https://github.com/benhoyt/inih.git'")
endif()

execute_process(
  COMMAND "/usr/bin/git"  checkout r44 --
  WORKING_DIRECTORY "/tmp/qzdl.git.x4WS1h/build/_deps/inih-src"
  RESULT_VARIABLE error_code
  )
if(error_code)
  message(FATAL_ERROR "Failed to checkout tag: 'r44'")
endif()

set(init_submodules TRUE)
if(init_submodules)
  execute_process(
    COMMAND "/usr/bin/git"  submodule update --recursive --init 
    WORKING_DIRECTORY "/tmp/qzdl.git.x4WS1h/build/_deps/inih-src"
    RESULT_VARIABLE error_code
    )
endif()
if(error_code)
  message(FATAL_ERROR "Failed to update submodules in: '/tmp/qzdl.git.x4WS1h/build/_deps/inih-src'")
endif()

# Complete success, update the script-last-run stamp file:
#
execute_process(
  COMMAND ${CMAKE_COMMAND} -E copy
    "/tmp/qzdl.git.x4WS1h/build/_deps/inih-subbuild/inih-populate-prefix/src/inih-populate-stamp/inih-populate-gitinfo.txt"
    "/tmp/qzdl.git.x4WS1h/build/_deps/inih-subbuild/inih-populate-prefix/src/inih-populate-stamp/inih-populate-gitclone-lastrun.txt"
  RESULT_VARIABLE error_code
  )
if(error_code)
  message(FATAL_ERROR "Failed to copy script-last-run stamp file: '/tmp/qzdl.git.x4WS1h/build/_deps/inih-subbuild/inih-populate-prefix/src/inih-populate-stamp/inih-populate-gitclone-lastrun.txt'")
endif()

